from lxml import etree
from StringIO import StringIO
from django.utils.html import escape
from django.utils.safestring import mark_safe


def safe_html(str):
    allow = ["a", "b", "i", "strong", "em", "span"]

    try:
        tree = etree.parse(StringIO(str), etree.HTMLParser())
        root = tree.getroot()
        if root.tag == "html":
            root = root[0]
        if root.tag == "body":
            root = root[0]

        def rec(e):
            if e.tag not in allow:
                e.tag = "span"
            [rec(kid) for kid in e.getchildren()]

        rec(root)

        return mark_safe(etree.tostring(root))
    except:
        return mark_safe(escape(str))
